<?php
/*
Plugin Name: Enable Image Scaling on Upload
Plugin URI: http://www.werdswords.com
Description: This enables use and display of the image scaling option that comes with the new uploader introduced in WordPress 3.3.
Version: 0.2
Author: Drew Jaynes
Author URI: http://www.werdswords.com
License: GPLv2
*/

// Disclaimer: About 98% of this code came from media_upload_max_image_resize() located in wp-admin/includes/media.php
// I've merely restructured and reworded the displayed description for clarity.

function media_upload_display_scale_option() {
	$checked = get_user_setting('upload_resize') ? ' checked="true"' : '';
	$a = $end = '';

	if ( current_user_can( 'manage_options' ) ) {
		$a = '<a href="' . esc_url( admin_url( 'options-media.php' ) ) . '" target="_blank">';
		$end = '</a>';
	}
?>
<p class="hide-if-no-js"><label>
<input name="image_resize" type="checkbox" id="image_resize" value="true"<?php echo $checked; ?> />
<?php
	print( __( 'Scale down large images' ) );
?>
</label></p>
<p class="hide-if-no-js">
<?php
	/* translators: %1$s is link start tag, %2$s is link end tag, %3$d is width, %4$d is height*/
	printf( __( 'If your images exceed the large-size dimensions saved in %1$smedia settings%2$s (%3$d &times; %4$d) they will be proportionally scaled down during upload.' ), $a, $end, (int) get_option( 'large_size_w', '1024' ), (int) get_option( 'large_size_h', '1024' ) );
?>
</p>
<?php
}

add_action( 'post-upload-ui', 'media_upload_display_scale_option' );

?>
